Subject: Re: 2.6.30-rc6: Reported regressions from 2.6.29

From: Jeff Mahoney <[email-masked]>
Date: Sun, 17 May 2009 09:59:30 -0400

Stefan Richter wrote:
> Rafael J. Wysocki wrote:
>> On Sunday 17 May 2009, Ingo Molnar wrote:
>>> * Rafael J. Wysocki <[email-masked]> wrote:
>>>> Bug-Entry    : http://bugzilla.kernel.org/show_bug.cgi?id=13321
>>>> Subject        : kernel crash with NULL pointer when boot
>>>> Submitter    : Martin Bammer <[email-masked]>
>>>> Date        : 2009-05-16 12:37 (1 days old)
>>>> References    : http://lkml.org/lkml/2009/5/16/100
>>> that crash is in reiserfs_for_each_xattr(), during sys_unlink()'s
>>> xattr teardown.
>>>
>>> There's been a good deal of reiserfs changes in this cycle - some
>>> touch the xattr code as well. Some of them fairly late in the cycle,
> 
> (Also, the bug is reportedly a post -rc5 regression.)
> 
>>> in the last two weeks:
>>>
>>>  earth4:~/tip> gll v2.6.29..linus --since=two-weeks-ago fs/reiserfs/
>>>  2a32ceb: Fix races around the access to ->s_options
>>>  677c9b2: reiserfs: remove privroot hiding in lookup
>>>  b82bb72: reiserfs: dont associate security.* with xattr files
>>>  ab17c4f: reiserfs: fixup xattr_root caching
>>>  edcc37a: Always lookup priv_root on reiserfs mount and keep it
>>>  5a6059c: reiserfs: Expand i_mutex to enclose lookup_one_len
>>>
>>> Martin, you could try a blind revert of say ... ab17c4f, which looks
>>> the most suspect and which is also a rather large commit.
>>>
>>> Or/and you could try a bisect - perhaps accelerated via:
>>>
>>>    git bisect start fs/reiserfs/
>>
>> I think there's a fix already for this in the works, but it hasn't
>> been merged
>> yet.  It looks like Jeff has just posted some reiserfs fixes. :-)
> 
> I'd say Martin should try Jeff's pending patches before a revert or
> before starting a bisection.  Either apply them from
> http://lkml.org/lkml/2009/5/17/6, or pull from
>  git://git.kernel.org/pub/scm/linux/kernel/git/viro/vfs-2.6.git for-next
> or wait for them to appear in Linus' tree...
> 
> I for one didn't test the post v2.6.30-rc5 changes to reiserfs, but I
> did try them _together_ with the four pending patches on a system with
> reiserfs root filesystem and extended attributes disabled in the config.
> Everything is fine here after almost a week uptime.

Yes, this bug is known and is fixed with "[patch 2/4] [PATCH] reiserfs:
deal with NULL xattr root w/ xattrs disabled"

- -Jeff

- --
Jeff Mahoney
SUSE Labs